package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLASTOperation_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLASTOperation extends ISLASTExpression  {
	
	/* @generated */
	protected ISLASTOperation(long ptr) {
		/*** PROTECTED REGION ID(ISLASTOperation_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLASTOperation build(long ptr) {
		return new ISLASTOperation(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLASTOperation_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_ast_expr_get_op_type 
	 * 
	 * @generated
	**/
	public ISLASTOpType getOpType() {
		/*** PROTECTED REGION ID(isl_ast_expr_get_op_type) DISABLED START ***/
		ISLASTOpType res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTOpType.build(ISLNative.isl_ast_expr_get_op_type(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_get_op_n_arg 
	 * 
	 * @generated
	**/
	public int getNbArgs() {
		/*** PROTECTED REGION ID(isl_ast_expr_get_op_n_arg) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_ast_expr_get_op_n_arg(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_get_op_arg 
	 * 
	 * @generated
	**/
	public ISLASTExpression getArgument(int pos) {
		/*** PROTECTED REGION ID(isl_ast_expr_get_op_arg) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_expr_get_op_arg(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLASTExpressionVisitor visitor) {
		visitor.visitISLASTOperation(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLASTOperation_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
